<?php
require_once __DIR__ . '/../../vendor/autoload.php'; 
use Komplettnettbutikk\Pakkepost\PakkepostBooking;

class AdminKoPakkepostBookingGenerateLabelController extends ModuleAdminController
{
    public function postProcess(){
        $id_order = Tools::getValue("id_order");
        $productId = Tools::getValue('productId');
        $numberOfPackages = Tools::getValue('numberOfPackages');
        $order = new Order($id_order);
        $delivery_address = new Address($order->id_address_delivery); 
        $customer = new Customer($order->id_customer);
        $phone = $delivery_address->phone_mobile;
        if(!$phone)
            $phone = $delivery_address->phone;

        $recipientName = $delivery_address->firstname . ' ' . $delivery_address->lastname;

        if($delivery_address->company && $delivery_address->company != '') 
           $recipientName =  $delivery_address->company . $recipientName;

        $addressLineNumber = '';
        if(!empty($delivery_address->address2))
           $addressLineNumber = $delivery_address->address2;

        $numberOfPackages = 1;

        $shipment = [
            "userId" =>                     (int) Configuration::get($this->module->name.'_'.'user_id'),
            "senderName"=>                  substr(Configuration::get($this->module->name.'_'.'senderName'), 0, 35),
            "senderAddressLine"=>           substr(Configuration::get($this->module->name.'_'.'senderAddressLine'), 0, 35),
            "senderAddressLineNumber"=>     Configuration::get($this->module->name.'_'.'senderAddressLineNumber'),
            "senderPostalCode"=>            Configuration::get($this->module->name.'_'.'senderPostalCode'),
            "senderCity"=>                  substr(Configuration::get($this->module->name.'_'.'senderCity'), 0, 25),
            "senderReference"=>             'WEBORDRE '.$id_order,
            "senderEmail"=>                 Configuration::get($this->module->name.'_'.'senderEmail'),
            "senderPhoneNumber"=>           str_replace('+47', '', Configuration::get($this->module->name.'_'.'senderPhoneNumber')),
            "recipientName"=>               substr($recipientName, 0, 35),
            "recipientAddressLine"=>        substr($delivery_address->address1, 0, 25),
            "recipientAddressLineNumber"=>  substr($addressLineNumber, 0, 10),//null,//$addressLineNumber,
            "recipientPostalCode"=>         $delivery_address->postcode,
            "recipientCity"=>               substr($delivery_address->city, 0, 25),
            "recipientReference"=>          '',//null, //substr($recipient_ref, 0, 10),
            "recipientPhoneNumber"=>        str_replace('+47', '', $phone),
            "recipientEmail"=>              $customer->email,
            "productId"=>                   (int)$productId,
            "additionalServices"=>          "hjemlevering",
            "numberOfPackages"=>            (int) $numberOfPackages
        ];
        
        $shipments = [$shipment];
        // dump($shipments);die();
        $pp = new PakkepostBooking;

        if($url = $pp->getPaymentUrl($shipments))
            header('Location: '.$url);
        else
            die('en feil oppsto');
    }
}